Capture stdout and stderr into different variables
Asked Answered
S

21

120

Is it possible to store or capture stdout and stderr in different variables, without using a temp file? Right now I do this to get stdout in out and stderr in err when running some_command, but I'd like to avoid the temp file.

error_file=$(mktemp)
out=$(some_command 2>$error_file)
err=$(< $error_file)
rm $error_file
Spanjian answered 14/6, 2012 at 6:19 Comment(5)
This question includes my question, but does not answer it.Spanjian
fwiw, it's possible in ksh93. ksh -c 'function f { echo out; echo err >&2; }; x=${ { y=$(f); } 2>&1;}; typeset -p x y'Heger
@ormaaj: can you explain how the ksh93 technique works? You might need make it an answer.Getupandgo
possible duplicate of capture both stdout and stderr in bashRondure
@Rondure Well, that question is posterior to this one, so, if there is a duplicate, it should be that one: capture both stdout and stderr in bash:-DHussein
L
51

Ok, it got a bit ugly, but here is a solution:

unset t_std t_err
eval "$( (echo std; echo err >&2) \
        2> >(readarray -t t_err; typeset -p t_err) \
         > >(readarray -t t_std; typeset -p t_std) )"

where (echo std; echo err >&2) needs to be replaced by the actual command. Output of stdout is saved into the array $t_std line by line omitting the newlines (the -t) and stderr into $t_err.

If you don't like arrays you can do

unset t_std t_err
eval "$( (echo std; echo err >&2 ) \
        2> >(t_err=$(cat); typeset -p t_err) \
         > >(t_std=$(cat); typeset -p t_std) )"

which pretty much mimics the behavior of var=$(cmd) except for the value of $? which takes us to the last modification:

unset t_std t_err t_ret
eval "$( (echo std; echo err >&2; exit 2 ) \
        2> >(t_err=$(cat); typeset -p t_err) \
         > >(t_std=$(cat); typeset -p t_std); t_ret=$?; typeset -p t_ret )"

Here $? is preserved into $t_ret

Tested on Debian wheezy using GNU bash, Version 4.2.37(1)-release (i486-pc-linux-gnu).

Lone answered 6/8, 2013 at 17:20 Comment(13)
Good work! I tried to abstract your answer into a shell function, but its behaviour confuses me: eval "eval \"\$@\" 2> >($err=\$(cat); typeset -p $err) 1> >($out=\$(cat); typeset -p $out) ; \\echo \(exit \$?\)" results in the printing happening in opposite the expected order, i.e. it produces (exit <exit code>); declare -- <out variable>=<std out>; declare -- <err variable>=<std err> ???Spanjian
That is why I would handle return the same way. Try eval "$( eval "$@" 2> >(t_err=$(cat); typeset -p t_err) > >(t_std=$(cat); typeset -p t_std); t_ret=$?; typeset -p t_ret )"; exit $t_retLone
Thanks for the concept. I have expanded (distilled) it a bit in here: https://mcmap.net/q/41292/-capture-stdout-and-stderr-into-different-variablesHussein
typeset -p t_out and typeset -p t_err might be mixed, rending the output useless.Scheme
@Scheme I thought about that possibility but could not confirm that this can happen.Lone
@Lone Hmm, I think you are right. I was in Zsh and was using >>() instead of > >(). The former is a no-go in Bash; in Zsh it correctly parses out the process substitution part, but sometimes emits mangled output. Not sure why, but > >() seems to work reliably. I'm still not totally convinced though. typeset -p is definitely not atomic, is it?Scheme
THANK YOU VERY MUCH. Sorry It had to be in all caps, I was searching for this answer so long!Inobservance
Can the final version be wrapped in a function like eval-unpacked "echo std; echo err >&2; exit 2" t_stdout t_stderr t_ret?Blearyeyed
I managed to turn it into a function but it only works in ZSH: gist.github.com/cmcdragonkai/9d1589256053d24dd8d2ce163147c6b8Blearyeyed
If the script I try to capture the output of contains starting a PostgreSQL cluster (/usr/bin/pg_createcluster --start), the base script (which contains the capturing call) never gets past eval. The command after eval never runs and the script does not exit either, it just stops (waiting on someting?). Do you have any ideas how to work around this?Mcatee
I am not used to that command. Could it be asking for a password?Lone
My understanding of shell/bash is not very good. So I didn't understand these points... > unset -> Why use unset? > variable=$(cat) -> What does this construct with cat do? > typeset -p variable -> What does this construct with typeset -p do? > variable=$? -> What does $? do? Could someone explain? 😊Swallowtail
@EduardoLucio unset ensures that previous assignments to the variables are cleared (probably unneeded). $(cat) basically allows me to capture the current input stream (as selected through > >( / 2> >() by reading it and outputting it again; could I just assign a stream to a variable, I would do that instead. typeset -p outputs the definition of a variable in a format that can be used to recreate the variable with its value using eval. $? is the exit-code of the previous command.Lone
C
79

I think before saying “you can't” do something, people should at least give it a try with their own hands…

Simple and clean solution, without using eval or anything exotic

1. A minimal version

{
    IFS=$'\n' read -r -d '' CAPTURED_STDERR;
    IFS=$'\n' read -r -d '' CAPTURED_STDOUT;
} < <((printf '\0%s\0' "$(some_command)" 1>&2) 2>&1)

Requires: printf, read

2. A simple test

A dummy script for producing stdout and stderr: useless.sh

#!/bin/bash
#
# useless.sh
#

echo "This is stderr" 1>&2
echo "This is stdout" 

The actual script that will capture stdout and stderr: capture.sh

#!/bin/bash
#
# capture.sh
#

{
    IFS=$'\n' read -r -d '' CAPTURED_STDERR;
    IFS=$'\n' read -r -d '' CAPTURED_STDOUT;
} < <((printf '\0%s\0' "$(./useless.sh)" 1>&2) 2>&1)

echo 'Here is the captured stdout:'
echo "${CAPTURED_STDOUT}"
echo

echo 'And here is the captured stderr:'
echo "${CAPTURED_STDERR}"
echo

Output of capture.sh

Here is the captured stdout:
This is stdout

And here is the captured stderr:
This is stderr

3. How it works

The command

(printf '\0%s\0' "$(some_command)" 1>&2) 2>&1

sends the standard output of some_command to printf '\0%s\0', thus creating the string \0${stdout}\n\0 (where \0 is a NUL byte and \n is a new line character); the string \0${stdout}\n\0 is then redirected to the standard error, where the standard error of some_command was already present, thus composing the string ${stderr}\n\0${stdout}\n\0, which is then redirected back to the standard output.

Afterwards, the command

IFS=$'\n' read -r -d '' CAPTURED_STDERR;

starts reading the string ${stderr}\n\0${stdout}\n\0 up until the first NUL byte and saves the content into ${CAPTURED_STDERR}. Then the command

IFS=$'\n' read -r -d '' CAPTURED_STDOUT;

keeps reading the same string up to the next NUL byte and saves the content into ${CAPTURED_STDOUT}.

4. Making it unbreakable

The solution above relies on a NUL byte for the delimiter between stderr and stdout, therefore it will not work if for any reason stderr contains other NUL bytes.

Although that will rarely happen, it is possible to make the script completely unbreakable by stripping all possible NUL bytes from stdout and stderr before passing both outputs to read (sanitization) – NUL bytes would anyway get lost, as it is not possible to store them into shell variables:

{
    IFS=$'\n' read -r -d '' CAPTURED_STDOUT;
    IFS=$'\n' read -r -d '' CAPTURED_STDERR;
} < <((printf '\0%s\0' "$((some_command | tr -d '\0') 3>&1- 1>&2- 2>&3- | tr -d '\0')" 1>&2) 2>&1)

Requires: printf, read, tr

5. Preserving the exit status – the blueprint (without sanitization)

After thinking a bit about the ultimate approach, I have come out with a solution that uses printf to cache both stdout and the exit code as two different arguments, so that they never interfere.

The first thing I did was outlining a way to communicate the exit status to the third argument of printf, and this was something very easy to do in its simplest form (i.e. without sanitization).

{
    IFS=$'\n' read -r -d '' CAPTURED_STDERR;
    IFS=$'\n' read -r -d '' CAPTURED_STDOUT;
    (IFS=$'\n' read -r -d '' _ERRNO_; exit ${_ERRNO_});
} < <((printf '\0%s\0%d\0' "$(some_command)" "${?}" 1>&2) 2>&1)

Requires: exit, printf, read

6. Preserving the exit status with sanitization – unbreakable (rewritten)

Things get very messy though when we try to introduce sanitization. Launching tr for sanitizing the streams does in fact overwrite our previous exit status, so apparently the only solution is to redirect the latter to a separate descriptor before it gets lost, keep it there until tr does its job twice, and then redirect it back to its place.

After some quite acrobatic redirections between file descriptors, this is what I came out with.

The code below is a rewrite of a previous example (you can find it in the appendix below). It also sanitizes possible NUL bytes in the streams, so that read can always work properly.

{
    IFS=$'\n' read -r -d '' CAPTURED_STDOUT;
    IFS=$'\n' read -r -d '' CAPTURED_STDERR;
    (IFS=$'\n' read -r -d '' _ERRNO_; exit ${_ERRNO_});
} < <((printf '\0%s\0%d\0' "$(((({ some_command; echo "${?}" 1>&3-; } | tr -d '\0' 1>&4-) 4>&2- 2>&1- | tr -d '\0' 1>&4-) 3>&1- | exit "$(cat)") 4>&1-)" "${?}" 1>&2) 2>&1)

Requires: exit, printf, read, tr

This solution is really robust. The exit code is always kept separated in a different descriptor until it reaches printf directly as a separate argument.

7. The ultimate solution – a general purpose function with exit status

We can also transform the code above to a general purpose function.

# SYNTAX:
#   catch STDOUT_VARIABLE STDERR_VARIABLE COMMAND [ARG1[ ARG2[ ...[ ARGN]]]]
catch() {
    {
        IFS=$'\n' read -r -d '' "${1}";
        IFS=$'\n' read -r -d '' "${2}";
        (IFS=$'\n' read -r -d '' _ERRNO_; return ${_ERRNO_});
    } < <((printf '\0%s\0%d\0' "$(((({ shift 2; "${@}"; echo "${?}" 1>&3-; } | tr -d '\0' 1>&4-) 4>&2- 2>&1- | tr -d '\0' 1>&4-) 3>&1- | exit "$(cat)") 4>&1-)" "${?}" 1>&2) 2>&1)
}

Requires: cat, exit, printf, read, shift, tr

ChangeLog: 2022-06-17 // Replaced ${3} with shift 2; ${@} after Pavel Tankov's comment (Bash-only). 2023-01-18 // Replaced ${@} with "${@}" after cbugk's comment.

With the catch function we can launch the following snippet,

catch MY_STDOUT MY_STDERR './useless.sh'

echo "The \`./useless.sh\` program exited with code ${?}"
echo

echo 'Here is the captured stdout:'
echo "${MY_STDOUT}"
echo

echo 'And here is the captured stderr:'
echo "${MY_STDERR}"
echo

and get the following result:

The `./useless.sh` program exited with code 0

Here is the captured stdout:
This is stderr 1
This is stderr 2

And here is the captured stderr:
This is stdout 1
This is stdout 2

8. What happens in the last examples

Here follows a fast schematization:

  1. some_command is launched: we then have some_command's stdout on the descriptor 1, some_command's stderr on the descriptor 2 and some_command's exit code redirected to the descriptor 3
  2. stdout is piped to tr (sanitization)
  3. stderr is swapped with stdout (using temporarily the descriptor 4) and piped to tr (sanitization)
  4. the exit code (descriptor 3) is swapped with stderr (now descriptor 1) and piped to exit $(cat)
  5. stderr (now descriptor 3) is redirected to the descriptor 1, end expanded as the second argument of printf
  6. the exit code of exit $(cat) is captured by the third argument of printf
  7. the output of printf is redirected to the descriptor 2, where stdout was already present
  8. the concatenation of stdout and the output of printf is piped to read

9. The POSIX-compliant version #1 (breakable)

Process substitutions (the < <() syntax) are not POSIX-standard (although they de facto are). In a shell that does not support the < <() syntax the only way to reach the same result is via the <<EOF … EOF syntax. Unfortunately this does not allow us to use NUL bytes as delimiters, because these get automatically stripped out before reaching read. We must use a different delimiter. The natural choice falls onto the CTRL+Z character (ASCII character no. 26). Here is a breakable version (outputs must never contain the CTRL+Z character, or otherwise they will get mixed).

_CTRL_Z_=$'\cZ'

{
    IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" CAPTURED_STDERR;
    IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" CAPTURED_STDOUT;
    (IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" _ERRNO_; exit ${_ERRNO_});
} <<EOF
$((printf "${_CTRL_Z_}%s${_CTRL_Z_}%d${_CTRL_Z_}" "$(some_command)" "${?}" 1>&2) 2>&1)
EOF

Requires: exit, printf, read

Note: As shift is Bash-only, in this POSIX-compliant version command + arguments must appear under the same quotes.

10. The POSIX-compliant version #2 (unbreakable, but not as good as the non-POSIX one)

And here is its unbreakable version, directly in function form (if either stdout or stderr contain CTRL+Z characters, the stream will be truncated, but will never be exchanged with another descriptor).

_CTRL_Z_=$'\cZ'

# SYNTAX:
#     catch_posix STDOUT_VARIABLE STDERR_VARIABLE COMMAND
catch_posix() {
    {
        IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" "${1}";
        IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" "${2}";
        (IFS=$'\n'"${_CTRL_Z_}" read -r -d "${_CTRL_Z_}" _ERRNO_; return ${_ERRNO_});
    } <<EOF
$((printf "${_CTRL_Z_}%s${_CTRL_Z_}%d${_CTRL_Z_}" "$(((({ ${3}; echo "${?}" 1>&3-; } | cut -z -d"${_CTRL_Z_}" -f1 | tr -d '\0' 1>&4-) 4>&2- 2>&1- | cut -z -d"${_CTRL_Z_}" -f1 | tr -d '\0' 1>&4-) 3>&1- | exit "$(cat)") 4>&1-)" "${?}" 1>&2) 2>&1)
EOF
}

Requires: cat, cut, exit, printf, read, tr

Answer's history

Here is a previous version of catch() before Pavel Tankov's comment (this version requires the additional arguments to be quoted together with the command):

# SYNTAX:
#  catch STDOUT_VARIABLE STDERR_VARIABLE COMMAND [ARG1[ ARG2[ ...[ ARGN]]]]
catch() {
  {
      IFS=$'\n' read -r -d '' "${1}";
      IFS=$'\n' read -r -d '' "${2}";
      (IFS=$'\n' read -r -d '' _ERRNO_; return ${_ERRNO_});
  } < <((printf '\0%s\0%d\0' "$(((({ shift 2; ${@}; echo "${?}" 1>&3-; } | tr -d '\0' 1>&4-) 4>&2- 2>&1- | tr -d '\0' 1>&4-) 3>&1- | exit "$(cat)") 4>&1-)" "${?}" 1>&2) 2>&1)
}

Requires: cat, exit, printf, read, tr

Furthermore, I replaced an old example for propagating the exit status to the current shell, because, as Andy had pointed out in the comments, it was not as “unbreakable” as it was supposed to be (since it did not use printf to buffer one of the streams). For the record I paste the problematic code here:

Preserving the exit status (still unbreakable)

The following variant propagates also the exit status of some_command to the current shell:

{
  IFS= read -r -d '' CAPTURED_STDOUT;
  IFS= read -r -d '' CAPTURED_STDERR;
  (IFS= read -r -d '' CAPTURED_EXIT; exit "${CAPTURED_EXIT}");
} < <((({ { some_command ; echo "${?}" 1>&3; } | tr -d '\0'; printf '\0'; } 2>&1- 1>&4- | tr -d '\0' 1>&4-) 3>&1- | xargs printf '\0%s\0' 1>&4-) 4>&1-)

Requires: printf, read, tr, xargs

Later, Andy submitted the following “suggested edit” for capturing the exit code:

Simple and clean solution saving the exit value

We can add to the end of stderr, a third piece of information, another NUL plus the exit status of the command. It will be outputted after stderr but before stdout

{
  IFS= read -r -d '' CAPTURED_STDERR;
  IFS= read -r -d '' CAPTURED_EXIT;
  IFS= read -r -d '' CAPTURED_STDOUT;
} < <((printf '\0%s\n\0' "$(some_command; printf '\0%d' "${?}" 1>&2)" 1>&2) 2>&1)

His solution seemed to work, but had the minor problem that the exit status needed to be placed as the last fragment of the string, so that we are able to launch exit "${CAPTURED_EXIT}" within round brackets and not pollute the global scope, as I had tried to do in the removed example. The other problem was that, as the output of his innermost printf got immediately appended to the stderr of some_command, we could no more sanitize possible NUL bytes in stderr, because among these now there was also our NUL delimiter.

Trying to find the right solution to this problem was what led me to write § 5. Preserving the exit status – the blueprint (without sanitization), and the following sections.

Coincident answered 4/1, 2020 at 16:56 Comment(24)
The last version does not work correctly. Try command find /proc as non root. The previous versions work wonderfully because you are using printf's argument to "buffer" stdout, guaranteeing that stdout is not printed until after the command is complete and 100% of stderr is streamed and flushed. However, the last version is not using printf to buffed one of the streams, only the exit code. Stderr and stdout are interleaved, and stderr only contains one flush's worth. If you fix, an explanation would be much appreciated, as I get lost after FD 4 is introducedUndecided
Hi Andy! Thanks for your comments and edit suggestion. What is the output of capture.sh on your machine after patching it with the third version?Coincident
Ok I see it now. The last version truncates stderr, right?Coincident
Yes. The result of the last version is that CAPTURED_STDOUT has stdout and most of stderr in it, and CAPTURED_STDERR only has the last bit of stderr (truncated, as you say). Without using printf to "buffer" one of the streams, you have no way to guarantee it is delayed until after the other stream is done streaming.Undecided
Good point. Your solution works, but has the minor problem that the exit status should represent the last piece of the string, if we want to be able to do exit "${CAPTURED_EXIT}" within round brackets for not polluting the global scope, as I have tried to do in my last example. The other problem is that, since the output of your innermost printf gets immediately appended to the stderr of some_command, we can no more sanitize possible NUL bytes in stderr, since among these there is also our NUL delimiter. I will think about something in the next days.Coincident
Yes, my solution is only a stepping stone.Undecided
Let us continue this discussion in chat.Undecided
If the script I try to capture the output of contains starting a PostgreSQL cluster (/usr/bin/pg_createcluster --start), the base script (which contains the capturing call) never gets past catch. The command after catch never runs and the script does not exit either, it just stops (waiting on someting?). Do you have any ideas how to work around this?Mcatee
This is genius... Awesome work... Just to clarify, is it correct that all \0 bytes are completely removed from every stream with the final solution via tr?Downandout
@Angel Thank you for your words. I assume you are talking about paragraphs #6 and #7; yes, if you don't remove all \0 bytes via tr they will be anyway removed as soon as you try to store the strings into shell variables. Shell variables cannot contain NUL bytes.Coincident
@JānisElmeris No idea. I am sorry.Coincident
@Coincident OK. For reference, what I found to work at the time, was the catch function of Tino's post (maybe your catch would work as well, I don't remember if I tried) to capture, but the script containing the PostgreSQL service starter had to be called like this { { command | tee -a $LOG;} 3>&1 1>&2 2>&3- | tee -a $LOG;} 3>&1 1>&2 2>&3-, which is ugly and loses the exit status for that script/command, but that's the best I could manage.Mcatee
While your initial solution is indeed a realtively simple, clean one, it gets very complex, as it evolves into and 'ultimate' solution. Admittedly, I couldn't come up with something like this. That said, I don't think, many people would be able to understand, i. e., maintain code based on your final solution, even after a short time, without re-iterating everything from scratch. So, while maybe technically excellent, I'd rather not use such a construct, which arguably isn't any simpler than the above and probably also has some notable performance impacts. Educationally great, though!Valery
@Valery You should use the solution that works best for you. I felt it was important to give choice and include an unbreakable solution. The latter can still be improved, although with a little bit more effort (it is complex to decipher).Coincident
I think for variant 7. "The ultimate solution – a general purpose function with exit status", you can modify the line like that: < <((printf '\0%s\0%d\0' "$(((({ shift 2; $@; echo "$?" 1>&3-; } | tr -d '\0' 1>&4-) 4>&2- 2>&1- | tr -d '\0' 1>&4-) 3>&1- | exit $(cat)) 4>&1-)" "$?" 1>&2) 2>&1) i.e. adding a shift 2 and then using $@ instead of $3 so that when calling the function you don't have to enclose the command in quotes: catch MY_STDOUT MY_STDERR ls fdasdf - this is more convenient than catch MY_STDOUT MY_STDERR "ls fdasdf"Romanticism
read -d is not POSIX compliant (for variant 9 & 10), also $(( breaks in some shells, $( ( is saferTarsier
For 8th, I had to quote ${@} as "${@}" to have _ERRNO_ as integer. Otherwise _ERRNO_ was set as ' 1>&4- ) 4>&2- 2>&1- | tr -d '. For context, this was while running catch VAR_STDOUT VAR_STDERR chroot "${some_path}" /bin/bash -c "${command}", where ${command} is a multiline script as string.Harelda
I could not understand how markdown worked for comments. I removed a previous comment and posted it instead as an answer.Fabrin
Hello @Coincident Thank you for detailed solution. I have a bash script which invokes a "program" and I want to read the messages from the invoked "program" (from stdout) in the script. Will your solution "7. The ultimate solution – a general purpose function with exit status" work in this case?Leucoderma
@Leucoderma If you only need to read the standard output (without stderr) you must simply do MY_OUTPUT="$(program)". If instead you need to store both stdout and stderr, then yes, solution #7 was written for that.Coincident
Hello @madmurphy, thank you. Yes I would like to store both stdout and stderr. But, I have some issue storing it. My COMMAND is a program which internally executes system reboot and hence the stdout is not caught by the solution #7. Is there any way to capture stdout in this case?Leucoderma
Thank you for the detailed solution. At the end of #7, it appears that your example output is flipped. Here is the captured stdout: This is stderr 1Vacuum
I am speechless, you really went above and beyond with your answer. Thank you.Demiurge
@Leucoderma what about using usual 1>out.txt 2>err.txt assuming you can't place reboot trigger out of the program? You can read output files after system boot, account for your process ending up forcefully terminated though.Harelda
L
51

Ok, it got a bit ugly, but here is a solution:

unset t_std t_err
eval "$( (echo std; echo err >&2) \
        2> >(readarray -t t_err; typeset -p t_err) \
         > >(readarray -t t_std; typeset -p t_std) )"

where (echo std; echo err >&2) needs to be replaced by the actual command. Output of stdout is saved into the array $t_std line by line omitting the newlines (the -t) and stderr into $t_err.

If you don't like arrays you can do

unset t_std t_err
eval "$( (echo std; echo err >&2 ) \
        2> >(t_err=$(cat); typeset -p t_err) \
         > >(t_std=$(cat); typeset -p t_std) )"

which pretty much mimics the behavior of var=$(cmd) except for the value of $? which takes us to the last modification:

unset t_std t_err t_ret
eval "$( (echo std; echo err >&2; exit 2 ) \
        2> >(t_err=$(cat); typeset -p t_err) \
         > >(t_std=$(cat); typeset -p t_std); t_ret=$?; typeset -p t_ret )"

Here $? is preserved into $t_ret

Tested on Debian wheezy using GNU bash, Version 4.2.37(1)-release (i486-pc-linux-gnu).

Lone answered 6/8, 2013 at 17:20 Comment(13)
Good work! I tried to abstract your answer into a shell function, but its behaviour confuses me: eval "eval \"\$@\" 2> >($err=\$(cat); typeset -p $err) 1> >($out=\$(cat); typeset -p $out) ; \\echo \(exit \$?\)" results in the printing happening in opposite the expected order, i.e. it produces (exit <exit code>); declare -- <out variable>=<std out>; declare -- <err variable>=<std err> ???Spanjian
That is why I would handle return the same way. Try eval "$( eval "$@" 2> >(t_err=$(cat); typeset -p t_err) > >(t_std=$(cat); typeset -p t_std); t_ret=$?; typeset -p t_ret )"; exit $t_retLone
Thanks for the concept. I have expanded (distilled) it a bit in here: https://mcmap.net/q/41292/-capture-stdout-and-stderr-into-different-variablesHussein
typeset -p t_out and typeset -p t_err might be mixed, rending the output useless.Scheme
@Scheme I thought about that possibility but could not confirm that this can happen.Lone
@Lone Hmm, I think you are right. I was in Zsh and was using >>() instead of > >(). The former is a no-go in Bash; in Zsh it correctly parses out the process substitution part, but sometimes emits mangled output. Not sure why, but > >() seems to work reliably. I'm still not totally convinced though. typeset -p is definitely not atomic, is it?Scheme
THANK YOU VERY MUCH. Sorry It had to be in all caps, I was searching for this answer so long!Inobservance
Can the final version be wrapped in a function like eval-unpacked "echo std; echo err >&2; exit 2" t_stdout t_stderr t_ret?Blearyeyed
I managed to turn it into a function but it only works in ZSH: gist.github.com/cmcdragonkai/9d1589256053d24dd8d2ce163147c6b8Blearyeyed
If the script I try to capture the output of contains starting a PostgreSQL cluster (/usr/bin/pg_createcluster --start), the base script (which contains the capturing call) never gets past eval. The command after eval never runs and the script does not exit either, it just stops (waiting on someting?). Do you have any ideas how to work around this?Mcatee
I am not used to that command. Could it be asking for a password?Lone
My understanding of shell/bash is not very good. So I didn't understand these points... > unset -> Why use unset? > variable=$(cat) -> What does this construct with cat do? > typeset -p variable -> What does this construct with typeset -p do? > variable=$? -> What does $? do? Could someone explain? 😊Swallowtail
@EduardoLucio unset ensures that previous assignments to the variables are cleared (probably unneeded). $(cat) basically allows me to capture the current input stream (as selected through > >( / 2> >() by reading it and outputting it again; could I just assign a stream to a variable, I would do that instead. typeset -p outputs the definition of a variable in a format that can be used to recreate the variable with its value using eval. $? is the exit-code of the previous command.Lone
P
32

This is for catching stdout and stderr in different variables. If you only want to catch stderr, leaving stdout as-is, there is a better and shorter solution.

To sum everything up for the benefit of the reader, here is an

Easy Reusable bash Solution

This version does use subshells and runs without tempfiles. (For a tempfile version which runs without subshells, see my other answer.)

: catch STDOUT STDERR cmd args..
catch()
{
eval "$({
__2="$(
  { __1="$("${@:3}")"; } 2>&1;
  ret=$?;
  printf '%q=%q\n' "$1" "$__1" >&2;
  exit $ret
  )";
ret="$?";
printf '%s=%q\n' "$2" "$__2" >&2;
printf '( exit %q )' "$ret" >&2;
} 2>&1 )";
}

Example use:

dummy()
{
echo "$3" >&2
echo "$2" >&1
return "$1"
}

catch stdout stderr dummy 3 $'\ndiffcult\n data \n\n\n' $'\nother\n difficult \n  data  \n\n'

printf 'ret=%q\n' "$?"
printf 'stdout=%q\n' "$stdout"
printf 'stderr=%q\n' "$stderr"

this prints

ret=3
stdout=$'\ndiffcult\n data '
stderr=$'\nother\n difficult \n  data  '

So it can be used without deeper thinking about it. Just put catch VAR1 VAR2 in front of any command args.. and you are done.

Some if cmd args..; then will become if catch VAR1 VAR2 cmd args..; then. Really nothing complex.

Addendum: Use in "strict mode"

catch works for me identically in strict mode. The only caveat is, that the example above returns error code 3, which, in strict mode, calls the ERR trap. Hence if you run some command under set -e which is expected to return arbitrary error codes (not only 0), you need to catch the return code into some variable like && ret=$? || ret=$? as shown below:

dummy()
{
echo "$3" >&2
echo "$2" >&1
return "$1"
}

catch stdout stderr dummy 3 $'\ndifficult\n data \n\n\n' $'\nother\n difficult \n  data  \n\n' && ret=$? || ret=$?

printf 'ret=%q\n' "$ret"
printf 'stdout=%q\n' "$stdout"
printf 'stderr=%q\n' "$stderr"

Discussion

Q: How does it work?

It just wraps ideas from the other answers here into a function, such that it can easily be resused.

catch() basically uses eval to set the two variables. This is similar to https://stackoverflow.com/a/18086548

Consider a call of catch out err dummy 1 2a 3b:

  • let's skip the eval "$({ and the __2="$( for now. I will come to this later.

  • __1="$("$("${@:3}")"; } 2>&1; executes dummy 1 2a 3b and stores its stdout into __1 for later use. So __1 becomes 2a. It also redirects stderr of dummy to stdout, such that the outer catch can gather stdout

  • ret=$?; catches the exit code, which is 1

  • printf '%q=%q\n' "$1" "$__1" >&2; then outputs out=2a to stderr. stderr is used here, as the current stdout already has taken over the role of stderr of the dummy command.

  • exit $ret then forwards the exit code (1) to the next stage.

Now to the outer __2="$( ... )":

  • This catches stdout of the above, which is the stderr of the dummy call, into variable __2. (We could re-use __1 here, but I used __2 to make it less confusing.). So __2 becomes 3b

  • ret="$?"; catches the (returned) return code 1 (from dummy) again

  • printf '%s=%q\n' "$2" "$__2" >&2; then outputs err=3a to stderr. stderr is used again, as it already was used to output the other variable out=2a.

  • printf '( exit %q )' "$ret" >&2; then outputs the code to set the proper return value. I did not find a better way, as assigning it to a variable needs a variable name, which then cannot be used as first or second argument to catch.

Please note that, as an optimization, we could have written those 2 printf as a single one like printf '%s=%q\n( exit %q ) "$__2" "$ret"` as well.

So what do we have so far?

We have following written to stderr:

out=2a
err=3b
( exit 1 )

where out is from $1, 2a is from stdout of dummy, err is from $2, 3b is from stderr of dummy, and the 1 is from the return code from dummy.

Please note that %q in the format of printf takes care for quoting, such that the shell sees proper (single) arguments when it comes to eval. 2a and 3b are so simple, that they are copied literally.

Now to the outer eval "$({ ... } 2>&1 )";:

This executes all of above which output the 2 variables and the exit, catches it (therefor the 2>&1) and parses it into the current shell using eval.

This way the 2 variables get set and the return code as well.

Q: It uses eval which is evil. So is it safe?

  • As long as printf %q has no bugs, it should be safe. But you always have to be very careful, just think about ShellShock.

Q: Bugs?

  • No obvious bugs are known, except following:

    • Catching big output needs big memory and CPU, as everything goes into variables and needs to be back-parsed by the shell. So use it wisely.

    • As usual $(echo $'\n\n\n\n') swallows all linefeeds, not only the last one. This is a POSIX requirement. If you need to get the LFs unharmed, just add some trailing character to the output and remove it afterwards like in following recipe (look at the trailing x which allows to read a softlink pointing to a file which ends on a $'\n'):

          target="$(readlink -e "$file")x"
          target="${target%x}"
      
    • Shell-variables cannot carry the byte NUL ($'\0'). They are simply ignores if they happen to occur in stdout or stderr.

  • The given command runs in a sub-subshell. So it has no access to $PPID, nor can it alter shell variables. You can catch a shell function, even builtins, but those will not be able to alter shell variables (as everything running within $( .. ) cannot do this). So if you need to run a function in current shell and catch it's stderr/stdout, you need to do this the usual way with tempfiles. (There are ways to do this such, that interrupting the shell normally does not leave debris behind, but this is complex and deserves it's own answer.)

Q: Bash version?

  • I think you need Bash 4 and above (due to printf %q)

Q: This still looks so awkward.

  • Right. Another answer here shows how it can be done in ksh much more cleanly. However I am not used to ksh, so I leave it to others to create a similar easy to reuse recipe for ksh.

Q: Why not use ksh then?

  • Because this is a bash solution

Q: The script can be improved

  • Of course you can squeeze out some bytes and create smaller or more incomprehensible solution. Just go for it ;)

Q: There is a typo. : catch STDOUT STDERR cmd args.. shall read # catch STDOUT STDERR cmd args..

  • Actually this is intended. : shows up in bash -x while comments are silently swallowed. So you can see where the parser is if you happen to have a typo in the function definition. It's an old debugging trick. But beware a bit, you can easily create some neat sideffects within the arguments of :.

Edit: Added a couple more ; to make it more easy to create a single-liner out of catch(). And added section how it works.

Permafrost answered 9/12, 2016 at 22:8 Comment(8)
This is a very interesting solution considering that it makes such usage much more easier to use. You should however provide a little more details on how it works, considering that it does not follow the general pattern of other proposed solutions.Wax
How about doing this catch for commands that redirect one of the streams or are piping? It might seem questionable to try to capture both outputs is one of them is empty (since the command itself redirects it anyway). But it makes it easier to use same pattern over and over again with any command (especially if the command is externally provided and you don't know whether it redirects) even if in some cases one of the variables is doomed to be empty.Imena
So far I found a simple workaround. Just define a simple function like function echo_to_file { echo -n "$1" >"$2" ; } and then use catch with that function. Works as expected. But still it would be nice to have it in catch itself. (Similar "trick" can be done to have pipes in the command.)Imena
@AdamBadura the question was to catch 2 different variables in parallel. If you only want to capture one single variable, you do not need this catch here! Single variable capturing is built right into the shell: stdout+stderr: var="$(command 2>&1)"; echo "command gives $? and outputs '$var'"; catch stderr and redirect stdout: var="$(command 2>&1 >FILE)" (not >FILE 2>&1, this would redirect stderr to FILE!); stdout-only: var="$(command)"; echo "command gives $? and has stdout '$var'", and for stderr or other FDs see another answerPermafrost
In function catch, shouldn't the final printf statement be printf 'return %q\n' "$ret" >&2? One wants function catch to return cmd's exit code, rather than exiting the program.Duty
@JimFischer Nice catch, as eval "return 1" should return from catch as well (sorry for that pun). A quick test with bash worked for me. So, thanks, this seems to be an improvement and remove an unnecessary fork in the ( exit 1 ), which creates a subshell which immediately returns with code 1, so it does not exit the current program. However with the ( exit 1 ) in place this recipe can be dropped outside of functions as well. where return does not work. (Note: 1 is an example here.)Permafrost
Can fix it work work with "strict mode", please? It errors at the line } 2>&1 )";. I use this definition of strict mode: set -eEu -o pipefail; shopt -s extdebug; IFS=$'\n\t'; trap 'wickStrictModeFail $?' ERR, available at github.com/tests-always-included/wick/blob/master/doc/…Net
@Net Thanks for noting "strict mode". It happens to me that there seems to be no bug in catch (YMMV, perhaps there must be set +e inside the eval). catch is supposed to transparently return the error code of the called command. In the example dummy returns 3. Hence set -e fires the ERR trap as it is meant to do! By catching the error code into a variable in the catch invocation, the example also works in "strict mode". (Edited answer to add this note.) But note that the ERR location perhaps is a bit misleading. I do not know a good solution for this. Sorry.Permafrost
D
19

Technically, named pipes aren't temporary files and nobody here mentions them. They store nothing in the filesystem and you can delete them as soon as you connect them (so you won't ever see them):

#!/bin/bash -e

foo () {
    echo stdout1
    echo stderr1 >&2
    sleep 1
    echo stdout2
    echo stderr2 >&2
}

rm -f stdout stderr
mkfifo stdout stderr
foo >stdout 2>stderr &             # blocks until reader is connected
exec {fdout}<stdout {fderr}<stderr # unblocks `foo &`
rm stdout stderr                   # filesystem objects are no longer needed

stdout=$(cat <&$fdout)
stderr=$(cat <&$fderr)

echo $stdout
echo $stderr

exec {fdout}<&- {fderr}<&- # free file descriptors, optional

You can have multiple background processes this way and asynchronously collect their stdouts and stderrs at a convenient time, etc.

If you need this for one process only, you may just as well use hardcoded fd numbers like 3 and 4, instead of the {fdout}/{fderr} syntax (which finds a free fd for you).

Dip answered 16/10, 2015 at 9:6 Comment(2)
You would need to wait for the foo & subshell to complete to get it's exit code. For example, foo >stdout 2>stderr & pid=$!; exec {fdout}<stdout {fderr}<stderr; wait $pid; rc=$?Reviviscence
This helped me to finally solve separated handling of git stdout and stderr in combination with dialog prgbox, many thanks!Valery
H
15

This command sets both stdout (stdval) and stderr (errval) values in the present running shell:

eval "$( execcommand 2> >(setval errval) > >(setval stdval); )"

provided this function has been defined:

function setval { printf -v "$1" "%s" "$(cat)"; declare -p "$1"; }

Change execcommand to the captured command, be it "ls", "cp", "df", etc.


All this is based on the idea that we could convert all captured values to a text line with the help of the function setval, then setval is used to capture each value in this structure:

execcommand 2> CaptureErr > CaptureOut

Convert each capture value to a setval call:

execcommand 2> >(setval errval) > >(setval stdval)

Wrap everything inside an execute call and echo it:

echo "$( execcommand 2> >(setval errval) > >(setval stdval) )"

You will get the declare calls that each setval creates:

declare -- stdval="I'm std"
declare -- errval="I'm err"

To execute that code (and get the vars set) use eval:

eval "$( execcommand 2> >(setval errval) > >(setval stdval) )"

and finally echo the set vars:

echo "std out is : |$stdval| std err is : |$errval|

It is also possible to include the return (exit) value.
A complete bash script example looks like this:

#!/bin/bash --

# The only function to declare:
function setval { printf -v "$1" "%s" "$(cat)"; declare -p "$1"; }

# a dummy function with some example values:
function dummy { echo "I'm std"; echo "I'm err" >&2; return 34; }

# Running a command to capture all values
#      change execcommand to dummy or any other command to test.
eval "$( dummy 2> >(setval errval) > >(setval stdval); <<<"$?" setval retval; )"

echo "std out is : |$stdval| std err is : |$errval| return val is : |$retval|"
Hussein answered 1/3, 2015 at 16:47 Comment(3)
There is a race condition because declare does no atomic writes when the whole output is longer than 1008 bytes (Ubuntu 16.04, bash 4.3.46(1)). There is an implicite synchronization between the two setval calls for stdout and stderr (the cat in the setval for stderr cannot finish before the setval for stdout has closed stderr). However there is no synchronization of the setval retval, hence it can come anywhere between. In this case, retval is swallowed in one of the two other variables. So the retval case does not run reliably.Permafrost
I think I like this approach.. kinda. Is there a way to move that eval to a separate function and pass the command to it? When I try that, it doesn't declare the errval or stdval.Trashy
I made capturable(){...} (setval as written) and capture(){ eval "$( $@ 2> >(capturable stderr) > >(capturable stdout); )"; test -z "$stderr" }. capture make ... && echo "$stdout" || less <<<"$stderr" pages stderr or prints stdout if there is none. Does this work for you, or help you if it does?Halfbaked
H
14

Jonathan has the answer. For reference, this is the ksh93 trick. (requires a non-ancient version).

function out {
    echo stdout
    echo stderr >&2
}

x=${ { y=$(out); } 2>&1; }
typeset -p x y # Show the values

produces

x=stderr
y=stdout

The ${ cmds;} syntax is just a command substitution that doesn't create a subshell. The commands are executed in the current shell environment. The space at the beginning is important ({ is a reserved word).

Stderr of the inner command group is redirected to stdout (so that it applies to the inner substitution). Next, the stdout of out is assigned to y, and the redirected stderr is captured by x, without the usual loss of y to a command substitution's subshell.

It isn't possible in other shells, because all constructs which capture output require putting the producer into a subshell, which in this case, would include the assignment.

update: Now also supported by mksh.

Heger answered 23/6, 2012 at 20:9 Comment(3)
Thanks. The key point is that ${ ... } is not a sub-shell, which leaves the rest readily explicable. Neat trick, as long as you've got a ksh to use.Getupandgo
This is not an answer to the question. The question is about the bash, whereas your answer is valid on ksh.Scouting
@Scouting Obviously. Read the last paragraph.Heger
E
11

This is a diagram showing how @madmurphy's very neat solution works.

Diagram of @madmurhy's solution

And an indented version of the one-liner:

catch() {
  {
      IFS=$'\n' read -r -d '' "$out_var";
      IFS=$'\n' read -r -d '' "$err_var";
      (IFS=$'\n' read -r -d '' _ERRNO_; return ${_ERRNO_});
  }\
  < <(
    (printf '\0%s\0%d\0' \
      "$(
        (
          (
            (
              { ${3}; echo "${?}" 1>&3-; } | tr -d '\0' 1>&4-
            ) 4>&2- 2>&1- | tr -d '\0' 1>&4-
          ) 3>&1- | exit "$(cat)"
        ) 4>&1-
      )" "${?}" 1>&2
    ) 2>&1
  )
}
Etude answered 14/6, 2012 at 6:19 Comment(1)
Nice diagram, Jacques. I'm having a little trouble following your intent of the meaning of each of the horizontal lines. I originally assumed each horizontal line was a file descriptor but that's obviously not the case. Maybe you could add some axes labels and a legend?Animal
T
5

Did not like the eval, so here is a solution that uses some redirection tricks to capture program output to a variable and then parses that variable to extract the different components. The -w flag sets the chunk size and influences the ordering of std-out/err messages in the intermediate format. 1 gives potentially high resolution at the cost of overhead.

#######                                                                                                                                                                                                                          
# runs "$@" and outputs both stdout and stderr on stdin, both in a prefixed format allowing both std in and out to be separately stored in variables later.                                                                  
# limitations: Bash does not allow null to be returned from subshells, limiting the usefullness of applying this function to commands with null in the output.                                                                   
# example:                                                                                                                                                                                                                       
#  var=$(keepBoth ls . notHere)                                                                                                                                                                                                  
#  echo ls had the exit code "$(extractOne r "$var")"                                                                                                                                                                            
#  echo ls had the stdErr of "$(extractOne e "$var")"                                                                                                                                                                            
#  echo ls had the stdOut of "$(extractOne o "$var")"                                                                                                                                                                            
keepBoth() {                                                                                                                                                                                                                     
  (                                                                                                                                                                                                                              
    prefix(){                                                                                                                                                                                                                    
      ( set -o pipefail                                                                                                                                                                                                          
        base64 -w 1 - | (                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
          while read c                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
          do echo -E "$1" "$c"                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
          done                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
        )                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
      )                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
    }                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
    ( (                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
        "$@" | prefix o >&3                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
        echo  ${PIPESTATUS[0]} | prefix r >&3                                                                                                                                                                                                                                                                                                                                                                                                                                                           
      ) 2>&1 | prefix e >&1                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
    ) 3>&1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
  )                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       

extractOne() { # extract                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
  echo "$2" | grep "^$1" | cut --delimiter=' ' --fields=2 | base64 --decode -                                                                                                                                                                                                                                                                                                                                                                                                                           
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
Tenon answered 8/1, 2018 at 9:23 Comment(0)
P
4

For the benefit of the reader here is a solution using tempfiles.

The question was not to use tempfiles. However this might be due to the unwanted pollution of /tmp/ with tempfile in case the shell dies. In case of kill -9 some trap 'rm "$tmpfile1" "$tmpfile2"' 0 does not fire.

If you are in a situation where you can use tempfile, but want to never leave debris behind, here is a recipe.

Again it is called catch() (as my other answer) and has the same calling syntax:

catch stdout stderr command args..

# Wrappers to avoid polluting the current shell's environment with variables

: catch_read returncode FD variable
catch_read()
{
eval "$3=\"\`cat <&$2\`\"";
# You can use read instead to skip some fork()s.
# However read stops at the first NUL byte,
# also does no \n removal and needs bash 3 or above:
#IFS='' read -ru$2 -d '' "$3";
return $1;
}
: catch_1 tempfile variable comand args..
catch_1()
{
{
rm -f "$1";
"${@:3}" 66<&-;
catch_read $? 66 "$2";
} 2>&1 >"$1" 66<"$1";
}

: catch stdout stderr command args..
catch()
{
catch_1 "`tempfile`" "${2:-stderr}" catch_1 "`tempfile`" "${1:-stdout}" "${@:3}";
}

What it does:

  • It creates two tempfiles for stdout and stderr. However it nearly immediately removes these, such that they are only around for a very short time.

  • catch_1() catches stdout (FD 1) into a variable and moves stderr to stdout, such that the next ("left") catch_1 can catch that.

  • Processing in catch is done from right to left, so the left catch_1 is executed last and catches stderr.

The worst which can happen is, that some temporary files show up on /tmp/, but they are always empty in that case. (They are removed before they get filled.). Usually this should not be a problem, as under Linux tmpfs supports roughly 128K files per GB of main memory.

  • The given command can access and alter all local shell variables as well. So you can call a shell function which has sideffects!

  • This only forks twice for the tempfile call.

Bugs:

  • Missing good error handling in case tempfile fails.

  • This does the usual \n removal of the shell. See comment in catch_read().

  • You cannot use file descriptor 66 to pipe data to your command. If you need that, use another descriptor for the redirection, like 42 (note that very old shells only offer FDs up to 9).

  • This cannot handle NUL bytes ($'\0') in stdout and stderr. (NUL is just ignored. For the read variant everything behind a NUL is ignored.)

FYI:

  • Unix allows us to access deleted files, as long as you keep some reference to them around (such as an open filehandle). This way we can open and then remove them.
Permafrost answered 14/1, 2017 at 17:7 Comment(0)
L
3

In the bash realm, @madmurphy's "7. The ultimate solution – a general purpose function with exit status" is the way to go that I've been massively using everywhere. Based on my experience I'm contributing minor updates making it really "ultimate" also in the following two scenarios:

  1. complex command lines to have args correctly quoted and without the need of quoting the original commands which are now naturally typed as plain tokens. ( the replacement is this..."$(((({ "${@:3}" ; echo...)

  2. our trusted friend "debug" options. xtrace and verbose work by injecting text into stderr... You can immagine for how long I was baffled by the erratic behaviour of scripts that seemed to work perfectly well just before the catch... And the problem actually was quite subtler and required to take care of xtrace and verbose options as mentioned here https://unix.stackexchange.com/a/21944

One of my use case scenarios, where you'll get why the entire quoting mechanism was a problem is the following. Also, to detect the length of a video and do something else in case of error, I needed some debug before figuring out how this fast ffprobe command fails on the given video:

catch end err ffprobe -i "${filename}" -show_entries format=duration -v warning -of csv='p=0'

This, in my experience so far, is the ultimate ultimate ;-) one, and hope may serve you as well. Credits to @madmurphy and all other contributors.

catch() {
  if [ "$#" -lt 3 ]; then
     echo USAGE:  catch STDOUT_VAR STDERR_VAR COMMAND [CMD_ARGS...]
     echo 'stdout-> ${STDOUT_VAR}' 'stderr-> ${STDERR_VAR}' 'exit-> ${?}'
     echo -e "\n** NOTICE: FD redirects are used to make the magic happen."
     echo "   Shell's xtrace (set -x) and verbose (set -v) work by redirecting to stderr, which screws the magic up."
     echo "   xtrace (set -x) and verbose (set -v) modes are suspended during the execution of this function."
     return 1
  fi

  # check "verbose" option, turn if off if enabled, and save restore status USE_V
  [[ ${-/v} != $- ]] && set +v && USE_V="-v" || USE_V="+v"
  # check "xtrace" option, turn if off if enabled, and save restore status USE_X
  [[ ${-/x} != $- ]] && set +x && USE_X="-x" || USE_X="+x"
  
    {
        IFS=$'\n' read -r -d '' "${1}";
        IFS=$'\n' read -r -d '' "${2}";
        # restore the "xtrace" and "verbose" options before returning
        (IFS=$'\n' read -r -d '' _ERRNO_; set $USE_X; set $USE_V; return "${_ERRNO_}");
    } < <((printf '\0%s\0%d\0' "$(((({ "${@:3}" ; echo "${?}" 1>&3-; } | tr -d '\0' 1>&4-) 4>&2- 2>&1- | tr -d '\0' 1>&4-) 3>&1- | exit "$(cat)") 4>&1-)" "${?}" 1>&2) 2>&1)

}
Lalise answered 7/8, 2022 at 9:25 Comment(0)
G
2

Succinctly, I believe the answer is 'No'. The capturing $( ... ) only captures standard output to the variable; there isn't a way to get the standard error captured into a separate variable. So, what you have is about as neat as it gets.

Getupandgo answered 14/6, 2012 at 6:33 Comment(1)
@ormaaj: By the look of the answers based on eval, it seems that it is actually possible, but, as you point out, it basically boils down to ‘use a better shell or language’. It's not directly an answer to the question, but I came here with the same question and I think that, long-term, I'm going to switch to a shell based on a functional language such as Haskell.Upraise
S
2

What about... =D

GET_STDERR=""
GET_STDOUT=""
get_stderr_stdout() {
    GET_STDERR=""
    GET_STDOUT=""
    unset t_std t_err
    eval "$( (eval $1) 2> >(t_err=$(cat); typeset -p t_err) > >(t_std=$(cat); typeset -p t_std) )"
    GET_STDERR=$t_err
    GET_STDOUT=$t_std
}

get_stderr_stdout "command"
echo "$GET_STDERR"
echo "$GET_STDOUT"
Swallowtail answered 10/12, 2015 at 17:4 Comment(1)
This appears to be a wrapper around the first answer that doesn't add any new functionality. How is this different / more useful?Spanjian
H
2

One workaround, which is hacky but perhaps more intuitive than some of the suggestions on this page, is to tag the output streams, merge them, and split afterwards based on the tags. For example, we might tag stdout with a "STDOUT" prefix:

function someCmd {
    echo "I am stdout"
    echo "I am stderr" 1>&2
}

ALL=$({ someCmd | sed -e 's/^/STDOUT/g'; } 2>&1)
OUT=$(echo "$ALL" | grep    "^STDOUT" | sed -e 's/^STDOUT//g')
ERR=$(echo "$ALL" | grep -v "^STDOUT")

```

If you know that stdout and/or stderr are of a restricted form, you can come up with a tag which does not conflict with their allowed content.

Heptagon answered 2/6, 2016 at 21:19 Comment(4)
Did a more general way to do this that works for all outputs, see my answer to this question.Tenon
Does this risk that sed interprets the outut of someCmd? Potential unwanted code execution?Revengeful
@Revengeful AFAIK in the above examples sed will only interpret the string arguments, i.e. s/^/STDOUT/g and s/^STDOUT//g. Since these are fixed, known strings there is no injection/unwanted execution vector. The stdout and stderr of someCmd will flow through the stdin and stdout of sed; they will be edited but not executed. Likewise for the calls to grep.Heptagon
@Revengeful Note that I'm assuming that the stdout and stderr of someCmd will never contain a line beginning with the "sentinel" text STDOUT. If this doesn't hold we could pick a different sentinel; but if the output is arbitrary (e.g. user-defined) then this method cannot be used, since there is no way to distinguish any sentinel text from the data.Heptagon
D
1

WARNING: NOT (yet?) WORKING!

The following seems a possible lead to get it working without creating any temp files and also on POSIX sh only; it requires base64 however and due to the encoding/decoding may not be that efficient and use also "larger" memory.

  • Even in the simple case, it would already fail, when the last stderr line has no newline. This can be fixed at least in some cases with replacing exe with "{ exe ; echo >&2 ; }", i.e. adding a newline.
  • The main problem is however that everything seems racy. Try using an exe like:

    exe() { cat /usr/share/hunspell/de_DE.dic cat /usr/share/hunspell/en_GB.dic >&2 }

and you'll see that e.g. parts of the base64 encoded line is on the top of the file, parts at the end, and the non-decoded stderr stuff in the middle.

Well, even if the idea below cannot be made working (which I assume), it may serve as an anti-example for people who may falsely believe it could be made working like this.

Idea (or anti-example):

#!/bin/sh

exe()
{
        echo out1
        echo err1 >&2
        echo out2
        echo out3
        echo err2 >&2
        echo out4
        echo err3 >&2
        echo -n err4 >&2
}


r="$(  { exe  |  base64 -w 0 ; }  2>&1 )"

echo RAW
printf '%s' "$r"
echo RAW

o="$( printf '%s' "$r" | tail -n 1 | base64 -d )"
e="$( printf '%s' "$r" | head -n -1  )"
unset r    

echo
echo OUT
printf '%s' "$o"
echo OUT
echo
echo ERR
printf '%s' "$e"
echo ERR

gives (with the stderr-newline fix):

$ ./ggg 
RAW
err1
err2
err3
err4

b3V0MQpvdXQyCm91dDMKb3V0NAo=RAW

OUT
out1
out2
out3
out4OUT

ERR
err1
err2
err3
err4ERR

(At least on Debian's dash and bash)

Downtoearth answered 27/7, 2016 at 18:13 Comment(0)
U
1

Here is an variant of @madmurphy solution that should work for arbitrarily large stdout/stderr streams, maintain the exit return value, and handle nulls in the stream (by converting them to newlines)

function buffer_plus_null()
{
  local buf
  IFS= read -r -d '' buf || :
  echo -n "${buf}"
  printf '\0'
}

{
    IFS= time read -r -d '' CAPTURED_STDOUT;
    IFS= time read -r -d '' CAPTURED_STDERR;
    (IFS= read -r -d '' CAPTURED_EXIT; exit "${CAPTURED_EXIT}");
} < <((({ { some_command ; echo "${?}" 1>&3; } | tr '\0' '\n' | buffer_plus_null; } 2>&1 1>&4 | tr '\0' '\n' | buffer_plus_null 1>&4 ) 3>&1 | xargs printf '%s\0' 1>&4) 4>&1 )

Cons:

  • The read commands are the most expensive part of the operation. For example: find /proc on a computer running 500 processes, takes 20 seconds (while the command was only 0.5 seconds). It takes 10 seconds to read in the first time, and 10 seconds more to read the second time, doubling the total time.

Explanation of buffer

The original solution was to an argument to printf to buffer the stream, however with the need to have the exit code come last, one solution is to buffer both stdout and stderr. I tried xargs -0 printf but then you quickly started hitting "max argument length limits". So I decided a solution was to write a quick buffer function:

  1. Use read to store the stream in a variable
  2. This read will terminate when the stream ends, or a null is received. Since we already removed the nulls, it ends when the stream is closed, and returns non-zero. Since this is expected behavior we add || : meaning "or true" so that the line always evaluates to true (0)
  3. Now that I know the stream has ended, it's safe to start echoing it back out.
  4. echo -n "${buf}" is a builtin command and thus not limited to the argument length limit
  5. Lastly, add a null separator to the end.
Undecided answered 22/1, 2020 at 18:10 Comment(1)
I'm sorry, but just to clarify, what's the main addition to the original? Does the original option work for relatively large data (i.e. 5,000 kB) or not? It seems it does. Regarding the speed, the original takes 5.8s, the alternative - 9.9s for declare i; for (( i = 0; i < 20; i++ )); do dmesg; done code (5338099 characters).Downandout
I
1

This prefixes error messages (similar to the answer of @Warbo) and by that we are able to distinguish between stdout and stderr:

out=$(some_command 2> >(sed -e 's/^/stderr/g'))
err=$(echo "$out" | grep -oP "(?<=^stderr).*")
out=$(echo "$out" | grep -v '^stderr')

The (?<=string) part is called a positive lookbehind which excludes the string from the result.

How I use it

# cat ./script.sh
#!/bin/bash
# check script arguments
args=$(getopt -u -l "foo,bar" "fb" "$@" 2> >(sed -e 's/^/stderr/g') )
[[ $? -ne 0 ]] && echo -n "Error: " && echo "$args" | grep -oP "(?<=^stderr).*" && exit 1
mapfile -t args < <(xargs -n1 <<< "$args")
#
# ./script.sh --foo --bar --baz
# Error: getopt: unrecognized option '--baz'

Notes:

  • As you can see I don't need to filter for stdout as the condition already catched the error and stopped the script. So if the script does not stop, $args does not contain any prefixed content.
  • An alternative to sed -e 's/^/stderr/g' is xargs -d '\n' -I {} echo "stderr{}".

Variant to prefix stdout AND stderr

# smbclient localhost 1> >(sed -e 's/^/std/g') 2> >(sed -e 's/^/err/g')
std
stdlocalhost: Not enough '\' characters in service
stderrUsage: smbclient [-?EgBVNkPeC] [-?|--help] [--usage]
stderr        [-R|--name-resolve=NAME-RESOLVE-ORDER] [-M|--message=HOST]
stderr        [-I|--ip-address=IP] [-E|--stderr] [-L|--list=HOST]
stderr        [-m|--max-protocol=LEVEL] [-T|--tar=<c|x>IXFqgbNan]
stderr        [-D|--directory=DIR] [-c|--command=STRING] [-b|--send-buffer=BYTES]
stderr        [-t|--timeout=SECONDS] [-p|--port=PORT] [-g|--grepable]
stderr        [-B|--browse] [-d|--debuglevel=DEBUGLEVEL]
stderr        [-s|--configfile=CONFIGFILE] [-l|--log-basename=LOGFILEBASE]
stderr        [-V|--version] [--option=name=value]
stderr        [-O|--socket-options=SOCKETOPTIONS] [-n|--netbiosname=NETBIOSNAME]
stderr        [-W|--workgroup=WORKGROUP] [-i|--scope=SCOPE] [-U|--user=USERNAME]
stderr        [-N|--no-pass] [-k|--kerberos] [-A|--authentication-file=FILE]
stderr        [-S|--signing=on|off|required] [-P|--machine-pass] [-e|--encrypt]
stderr        [-C|--use-ccache] [--pw-nt-hash] service <password>
Incompletion answered 31/10, 2022 at 17:12 Comment(0)
H
1

This is an addendum to Jacques Gaudin's addendum to madmurphy's answer.

Unlike the source, this uses eval to execute multi-line command (multi-argument is ok as well thanks to "${@}").

Another caveat is this function will return 0 in any case, and output exit code to a third variable instead. IMO this is more apt for catch.

#!/bin/bash

# Overwrites existing values of provided variables in any case.
# SYNTAX:
#   catch STDOUT_VAR_NAME STDERR_VAR_NAME EXIT_CODE_VAR_NAME COMMAND1 [COMMAND2 [...]]
function catch() {
  {
    IFS=$'\n' read -r -d '' "${1}";
    IFS=$'\n' read -r -d '' "${2}";
    IFS=$'\n' read -r -d '' "${3}";

    return 0;
  }\
  < <(
    (printf '\0%s\0%d\0' \
      "$(
        (
          (
            (
              {
                shift 3;
                eval "${@}";
                echo "${?}" 1>&3-;
              } | tr -d '\0' 1>&4-
            ) 4>&2- 2>&1- | tr -d '\0' 1>&4-
          ) 3>&1- | exit "$(cat)"
        ) 4>&1-
      )" "${?}" 1>&2
    ) 2>&1
  )
}

# Simulation of here-doc
MULTILINE_SCRIPT_1='cat << EOF
foo
bar
with newlines
EOF
'

# Simulation of multiple streams
# Notice the lack of semi-colons, otherwise below code
# could become a one-liner and still work
MULTILINE_SCRIPT_2='echo stdout stream
echo error stream 1>&2
'

catch out err code "${MULTILINE_SCRIPT_1}" \
                                'printf "wait there is more\n" 1>&2'
printf "1)\n\tSTDOUT: ${out}\n\tSTDERR: ${err}\n\tCODE: ${code}\n"

echo ''

catch out err code "${MULTILINE_SCRIPT_2}" echo this multi-argument \
                                form works too '1>&2' \; \(exit 5\)
printf "2)\n\tSTDOUT: ${out}\n\tSTDERR: ${err}\n\tCODE: ${code}\n"

Output:

1)
        STDOUT: foo
bar
with newlines
        STDERR: wait there is more
        CODE: 0

2)
        STDOUT: stdout stream
        STDERR: error stream
this multi-argument form works too
        CODE: 5
Harelda answered 30/11, 2022 at 11:22 Comment(0)
B
0

If the command 1) no stateful side effects and 2) is computationally cheap, the easiest solution is to just run it twice. I've mainly used this for code that runs during the boot sequence when you don't yet know if the disk is going to be working. In my case it was a tiny some_command so there was no performance hit for running twice, and the command had no side effects.

The main benefit is that this is clean and easy to read. The solutions here are quite clever, but I would hate to be the one that has to maintain a script containing the more complicated solutions. I'd recommend the simple run-it-twice approach if your scenario works with that, as it's much cleaner and easier to maintain.

Example:

output=$(getopt -o '' -l test: -- "$@")
errout=$(getopt -o '' -l test: -- "$@" 2>&1 >/dev/null)
if [[ -n "$errout" ]]; then
        echo "Option Error: $errout"
fi

Again, this is only ok to do because getopt has no side effects. I know it's performance-safe because my parent code calls this less than 100 times during the entire program, and the user will never notice 100 getopt calls vs 200 getopt calls.

Birdt answered 18/6, 2014 at 21:53 Comment(3)
Could you give an example? I'm guessing something like out=$(some_command) and err=$(some_command 2>&1 1>/dev/null)?Spanjian
@eicto - then you'll have to use one of the solutions above - this is only a good solution if your command has no side effects and is computationally cheapBirdt
I doubt that there are many use-cases that require separate handling of stdout and stderr that are free of side-effects – even if a command is deterministic under normal circumstances, errors are not normal circumstances. This approach will also likely be prone to race conditions.Upraise
S
0

Here's a simpler variation that isn't quite what the OP wanted, but is unlike any of the other options. You can get whatever you want by rearranging the file descriptors.

Test command:

%> cat xx.sh  
#!/bin/bash
echo stdout
>&2 echo stderr

which by itself does:

%> ./xx.sh
stdout
stderr

Now, print stdout, capture stderr to a variable, & log stdout to a file

%> export err=$(./xx.sh 3>&1 1>&2 2>&3 >"out")
stdout
%> cat out    
stdout
%> echo
$err 
stderr

Or log stdout & capture stderr to a variable:

export err=$(./xx.sh 3>&1 1>out 2>&3 )
%> cat out
stdout
%> echo $err
stderr

You get the idea.

Supinator answered 5/3, 2016 at 1:28 Comment(0)
G
0

Realtime output and write to file:

#!/usr/bin/env bash

# File where store the output
log_file=/tmp/out.log

# Empty file
echo > ${log_file}

outToLog() {
  # File where write (first parameter)
  local f="$1"
  # Start file output watcher in background
  tail -f "${f}" &
  # Capture background process PID
  local pid=$!
  # Write "stdin" to file
  cat /dev/stdin >> "${f}"
  # Kill background task
  kill -9 ${pid}
}

(
  # Long execution script example
  echo a
  sleep 1
  echo b >&2
  sleep 1
  echo c >&2
  sleep 1
  echo d
) 2>&1 | outToLog "${log_file}"

# File result
echo '==========='
cat "${log_file}"
Gapin answered 17/12, 2020 at 18:14 Comment(0)
Y
0

I've posted my solution to this problem here. It does use process substitution and requires Bash > v4 but also captures stdout, stderr and return code into variables you name in the current scope:

https://gist.github.com/pmarreck/5eacc6482bc19b55b7c2f48b4f1db4e8

The whole point of this exercise was so that I could assert on these things in a test suite. The fact that I just spent all afternoon figuring out this simple-sounding thing... I hope one of these solutions helps others!

Yung answered 25/10, 2021 at 22:28 Comment(0)

© 2022 - 2024 — McMap. All rights reserved.